diff --git a/liboctave/operators/mx-inlines.cc b/liboctave/operators/mx-inlines.cc
--- a/liboctave/operators/mx-inlines.cc
+++ b/liboctave/operators/mx-inlines.cc
@@ -1143,24 +1317,54 @@ OP_MINMAX_FCNN (mx_inline_max)
     octave_idx_type j = 0;                                              \
     if (octave::math::isnan (tmp))                                      \
       {                                                                 \
+        if (includenan)                                                 \
+          {                                                             \
+            for (; j < n; j++)                                          \
+              r[j] = tmp;                                               \
+            return;                                                     \
+          }                                                             \
         for (; i < n && octave::math::isnan (v[i]); i++) ;              \
         for (; j < i; j++)                                              \
           r[j] = tmp;                                                   \
         if (i < n)                                                      \
           tmp = v[i];                                                   \
       }                                                                 \
-    for (; i < n; i++)                                                  \
-      if (v[i] OP tmp)                                                  \
-        {                                                               \
-          for (; j < i; j++)                                            \
-            r[j] = tmp;                                                 \
-          tmp = v[i];                                                   \
-        }                                                               \
+    if (includenan)                                                     \
+      {                                                                 \
+        for (; i < n; i++)                                              \
+          {                                                             \
+            if (v[i] OP tmp)                                            \
+              {                                                         \
+                for (; j < i; j++)                                      \
+                  r[j] = tmp;                                           \
+                tmp = v[i];                                             \
+              }                                                         \
+            else if (octave::math::isnan (v[i]))                        \
+              {                                                         \
+                for (; j < i; j++)                                      \
+                  r[j] = tmp;                                           \
+                for (; j < n; j++)                                      \
+                  r[j] = v[i];                                          \
+                return;                                                 \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+    else                                                                \
+      {                                                                 \
+        for (; i < n; i++)                                              \
+          if (v[i] OP tmp)                                              \
+            {                                                           \
+              for (; j < i; j++)                                        \
+                r[j] = tmp;                                             \
+              tmp = v[i];                                               \
+            }                                                           \
+      }                                                                 \
     for (; j < i; j++)                                                  \
       r[j] = tmp;                                                       \
   }                                                                     \
   template <typename T>                                                 \
-  void F (const T *v, T *r, octave_idx_type *ri, octave_idx_type n)     \
+  void F (const T *v, T *r, octave_idx_type *ri, octave_idx_type n,     \
+          bool includenan)                                              \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
@@ -1170,6 +1374,15 @@ OP_MINMAX_FCNN (mx_inline_max)
     octave_idx_type j = 0;                                              \
     if (octave::math::isnan (tmp))                                      \
       {                                                                 \
+        if (includenan)                                                 \
+          {                                                             \
+            for (; j < n; j++)                                          \
+              {                                                         \
+                r[j] = tmp;                                             \
+                ri[j] = 0;                                              \
+              }                                                         \
+            return;                                                     \
+          }                                                             \
         for (; i < n && octave::math::isnan (v[i]); i++) ;              \
         for (; j < i; j++)                                              \
           {                                                             \
@@ -1182,17 +1395,50 @@ OP_MINMAX_FCNN (mx_inline_max)
             tmpi = i;                                                   \
           }                                                             \
       }                                                                 \
-    for (; i < n; i++)                                                  \
-      if (v[i] OP tmp)                                                  \
-        {                                                               \
-          for (; j < i; j++)                                            \
+    if (includenan)                                                     \
+      {                                                                 \
+        for (; i < n; i++)                                              \
+          {                                                             \
+            if (v[i] OP tmp)                                            \
+              {                                                         \
+                for (; j < i; j++)                                      \
+                  {                                                     \
+                    r[j] = tmp;                                         \
+                    ri[j] = tmpi;                                       \
+                  }                                                     \
+                tmp = v[i];                                             \
+                tmpi = i;                                               \
+              }                                                         \
+            else if (octave::math::isnan (v[i]))                        \
+              {                                                         \
+                for (; j < i; j++)                                      \
+                  {                                                     \
+                    r[j] = tmp;                                         \
+                    ri[j] = tmpi;                                       \
+                  }                                                     \
+                for (; j < n; j++)                                      \
+                  {                                                     \
+                    r[j] = v[i];                                        \
+                    ri[j] = i;                                          \
+                  }                                                     \
+                return;                                                 \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+    else                                                                \
+      {                                                                 \
+        for (; i < n; i++)                                              \
+          if (v[i] OP tmp)                                              \
             {                                                           \
-              r[j] = tmp;                                               \
-              ri[j] = tmpi;                                             \
+              for (; j < i; j++)                                        \
+                {                                                       \
+                  r[j] = tmp;                                           \
+                  ri[j] = tmpi;                                         \
+                }                                                       \
+              tmp = v[i];                                               \
+              tmpi = i;                                                 \
             }                                                           \
-          tmp = v[i];                                                   \
-          tmpi = i;                                                     \
-        }                                                               \
+      }                                                                 \
     for (; j < i; j++)                                                  \
       {                                                                 \
         r[j] = tmp;                                                     \
@@ -1210,100 +1456,103 @@ OP_CUMMINMAX_FCN (mx_inline_cummax, >)
 #define OP_CUMMINMAX_FCN2(F, OP)                                        \
   template <typename T>                                                 \
   inline void                                                           \
-  F (const T *v, T *r, octave_idx_type m, octave_idx_type n)            \
+  F (const T *v, T *r, octave_idx_type m, octave_idx_type n,            \
+     bool includenan)                                                   \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
-    bool nan = false;                                                   \
     const T *r0;                                                        \
     octave_idx_type j = 0;                                              \
-    for (octave_idx_type i = 0; i < m; i++)                             \
+    if (includenan)                                                     \
       {                                                                 \
-        r[i] = v[i];                                                    \
-        if (octave::math::isnan (v[i]))                                 \
-          nan = true;                                                   \
+        for (octave_idx_type i = 0; i < m; i++)                         \
+          r[i] = v[i];                                                  \
+        j++;                                                            \
+        v += m;                                                         \
+        r0 = r;                                                         \
+        r += m;                                                         \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (v[i] OP r0[i] || (octave::math::isnan (v[i])        \
+                                      && ! octave::math::isnan (r0[i])))\
+                  r[i] = v[i];                                          \
+                else                                                    \
+                  r[i] = r0[i];                                         \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+          }                                                             \
       }                                                                 \
-    j++;                                                                \
-    v += m;                                                             \
-    r0 = r;                                                             \
-    r += m;                                                             \
-    while (nan && j < n)                                                \
+    else                                                                \
       {                                                                 \
-        nan = false;                                                    \
+        bool nan = false;                                               \
         for (octave_idx_type i = 0; i < m; i++)                         \
           {                                                             \
+            r[i] = v[i];                                                \
             if (octave::math::isnan (v[i]))                             \
-              {                                                         \
-                r[i] = r0[i];                                           \
-                nan = true;                                             \
-              }                                                         \
-            else if (octave::math::isnan (r0[i]) || v[i] OP r0[i])      \
-              r[i] = v[i];                                              \
-            else                                                        \
-              r[i] = r0[i];                                             \
+              nan = true;                                               \
           }                                                             \
         j++;                                                            \
         v += m;                                                         \
         r0 = r;                                                         \
         r += m;                                                         \
-      }                                                                 \
-    while (j < n)                                                       \
-      {                                                                 \
-        for (octave_idx_type i = 0; i < m; i++)                         \
-          if (v[i] OP r0[i])                                            \
-            r[i] = v[i];                                                \
-          else                                                          \
-            r[i] = r0[i];                                               \
-        j++;                                                            \
-        v += m;                                                         \
-        r0 = r;                                                         \
-        r += m;                                                         \
+        while (nan && j < n)                                            \
+          {                                                             \
+            nan = false;                                                \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    r[i] = r0[i];                                       \
+                    if (octave::math::isnan (r[i]))                     \
+                      nan = true;                                       \
+                  }                                                     \
+                else if (octave::math::isnan (r0[i]) || v[i] OP r0[i])  \
+                  r[i] = v[i];                                          \
+                else                                                    \
+                  r[i] = r0[i];                                         \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+          }                                                             \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (v[i] OP r0[i])                                      \
+                  r[i] = v[i];                                          \
+                else                                                    \
+                  r[i] = r0[i];                                         \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+          }                                                             \
       }                                                                 \
   }                                                                     \
   template <typename T>                                                 \
   inline void                                                           \
   F (const T *v, T *r, octave_idx_type *ri,                             \
-     octave_idx_type m, octave_idx_type n)                              \
+     octave_idx_type m, octave_idx_type n, bool includenan)             \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
-    bool nan = false;                                                   \
     const T *r0;                                                        \
     const octave_idx_type *r0i;                                         \
     octave_idx_type j = 0;                                              \
-    for (octave_idx_type i = 0; i < m; i++)                             \
+    if (includenan)                                                     \
       {                                                                 \
-        r[i] = v[i]; ri[i] = 0;                                         \
-        if (octave::math::isnan (v[i]))                                 \
-          nan = true;                                                   \
-      }                                                                 \
-    j++;                                                                \
-    v += m;                                                             \
-    r0 = r;                                                             \
-    r += m;                                                             \
-    r0i = ri;                                                           \
-    ri += m;                                                            \
-    while (nan && j < n)                                                \
-      {                                                                 \
-        nan = false;                                                    \
         for (octave_idx_type i = 0; i < m; i++)                         \
           {                                                             \
-            if (octave::math::isnan (v[i]))                             \
-              {                                                         \
-                r[i] = r0[i];                                           \
-                ri[i] = r0i[i];                                         \
-                nan = true;                                             \
-              }                                                         \
-            else if (octave::math::isnan (r0[i]) || v[i] OP r0[i])      \
-              {                                                         \
-                r[i] = v[i];                                            \
-                ri[i] = j;                                              \
-              }                                                         \
-            else                                                        \
-              {                                                         \
-                r[i] = r0[i];                                           \
-                ri[i] = r0i[i];                                         \
-              }                                                         \
+            r[i] = v[i];                                                \
+            ri[i] = 0;                                                  \
           }                                                             \
         j++;                                                            \
         v += m;                                                         \
@@ -1311,26 +1560,97 @@ OP_CUMMINMAX_FCN (mx_inline_cummax, >)
         r += m;                                                         \
         r0i = ri;                                                       \
         ri += m;                                                        \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (v[i] OP r0[i] || (octave::math::isnan (v[i])        \
+                                      && ! octave::math::isnan (r0[i])))\
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    ri[i] = j;                                          \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    r[i] = r0[i];                                       \
+                    ri[i] = r0i[i];                                     \
+                  }                                                     \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+            r0i = ri;                                                   \
+            ri += m;                                                    \
+          }                                                             \
       }                                                                 \
-    while (j < n)                                                       \
+    else                                                                \
       {                                                                 \
+        bool nan = false;                                               \
         for (octave_idx_type i = 0; i < m; i++)                         \
-          if (v[i] OP r0[i])                                            \
-            {                                                           \
-              r[i] = v[i];                                              \
-              ri[i] = j;                                                \
-            }                                                           \
-          else                                                          \
-            {                                                           \
-              r[i] = r0[i];                                             \
-              ri[i] = r0i[i];                                           \
-            }                                                           \
+          {                                                             \
+            r[i] = v[i]; ri[i] = 0;                                     \
+            if (octave::math::isnan (v[i]))                             \
+              nan = true;                                               \
+          }                                                             \
         j++;                                                            \
         v += m;                                                         \
         r0 = r;                                                         \
         r += m;                                                         \
         r0i = ri;                                                       \
         ri += m;                                                        \
+        while (nan && j < n)                                            \
+          {                                                             \
+            nan = false;                                                \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    r[i] = r0[i];                                       \
+                    ri[i] = r0i[i];                                     \
+                    if (octave::math::isnan (r[i]))                     \
+                      nan = true;                                       \
+                  }                                                     \
+                else if (octave::math::isnan (r0[i]) || v[i] OP r0[i])  \
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    ri[i] = j;                                          \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    r[i] = r0[i];                                       \
+                    ri[i] = r0i[i];                                     \
+                  }                                                     \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+            r0i = ri;                                                   \
+            ri += m;                                                    \
+          }                                                             \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (v[i] OP r0[i])                                      \
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    ri[i] = j;                                          \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    r[i] = r0[i];                                       \
+                    ri[i] = r0i[i];                                     \
+                  }                                                     \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+            r0 = r;                                                     \
+            r += m;                                                     \
+            r0i = ri;                                                   \
+            ri += m;                                                    \
+          }                                                             \
       }                                                                 \
   }
 
@@ -1341,7 +1661,7 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
   template <typename T>                                         \
   inline void                                                   \
   F (const T *v, T *r, octave_idx_type l,                       \
-     octave_idx_type n, octave_idx_type u)                      \
+     octave_idx_type n, octave_idx_type u, bool includenan)     \
   {                                                             \
     if (! n)                                                    \
       return;                                                   \
